# 08nov23 Software Lab. Alexander Burger

"Browser"

(symbols 'pico~browser 'android 'pico)

(local) *SaveJS

(start
   (call "mkdir" "-p" "db/")
   (load "browser/er.l" "browser/lib.l")
   (pool "db/browser")
   (load "browser/init.l")
   (autofill) )

(stop
   (pool)
   (off *ID *Dbs *Blob)
   (java CONTEXT 'exit null) )

(pilbox
   (<h3> "fh" "PilBox Browser")
   (<img> "browser/home.png" "Home"
      (and (info "browser/index.html") "browser/index.html") ) )
(java CONTEXT 'exit
   (pack (baseHRef) *SesId *Url) )
(menu "Browser"
   (form NIL
      (unless *PRG
         (wipe (; CONTEXT GUI))
         (and (; CONTEXT GUI Ex) (setq *BUrl @)) )
      (<style> "rel100"
         (gui '(+Var +TextField) '*BUrl 1) )
      (----)
      (gui '(+JS +Button) "@"
         '(loadUrl
            (or
               (pre? "https://" *BUrl)
               (pre? "http://" *BUrl)
               (pack "https://" *BUrl) ) ) )
      (<nbsp>)
      (gui '(+Able +JS +Button) '*BUrl ,"Copy"
         '(setPrimaryClip *BUrl) )
      (gui '(+Able +Button) '*BUrl "Source"
         '(loadUrl (baseHRef) *SesId "browser/source.l") )
      (gui '(+Able +Button) '*BUrl "Bookmark"
         '(put!> (bulk) 'bk *BUrl) )
      (gui '(+Able +JS +Button) '*BUrl ,"Clear"
         '(off *BUrl) )
      (----)
      (<style> "rel40"
         (gui '(+TextField) 1) )
      (gui '(+JS +Button) ,"Search in page"
         '(findAllAsync (val> (field -1))) )
      (gui '(+JS +Button) ,"Clear"
         '(clearMatches) )
      (----)
      (gui '(+Swap/R +Chart1) '(bk bulk) 3)
      (<table> 'chart ,"Bookmarks" '(NIL (btn) (btn))
         (do 12
            (<row> (alternating)
               (gui 1 '(+HttpField))
               (gui 2 '(+DelRowButton) NIL
                  '(text ,"Delete @1?" (curr)) )
               (gui 3 '(+BubbleButton)) ) ) )
      (scroll 12 T)
      (----)
      (gui '(+JS +Button) ,"Clear Form Data"
         '(clearFormData) )
      (gui '(+JS +Button) ,"Clear Cache"
         '(clearCache) )
      (gui '(+JS +Button) ,"Clear Cookies"
         '(removeAllCookies) )
      (<nbsp> 3)
      (gui '(+Style +Button)
         '(if (java (; CONTEXT GUI Config) 'getJavaScriptEnabled) "green" "red")
         '(if (java (; CONTEXT GUI Config) 'getJavaScriptEnabled) "JS off" "JS on")
         '(if (java (; CONTEXT GUI Config) 'getJavaScriptEnabled)
            (prog
               (java (; CONTEXT GUI Config) 'setJavaScriptEnabled NIL)
               (setq *SaveJS *JS) )
            (java (; CONTEXT GUI Config) 'setJavaScriptEnabled T)
            (setq *JS *SaveJS) ) ) )
   (<div> "searches"
      (<grid> "--."
         "Startpage" (<nbsp>)
         (<tag> "form"
            '((method . "get") (action . "https://www.startpage.com/do/search"))
            (<tag> "input" '((type . "text") (name . "query") (size . 24))) )
         "Wikipedia (de)" (<nbsp>)
         (<tag> "form"
            '((action . "https://de.wikipedia.org/wiki"))
            (<tag> "input" '((type . "text") (name . "search") (size . 24))) )
         "Wikipedia (en)" (<nbsp>)
         (<tag> "form"
            '((action . "https://en.wikipedia.org/wiki"))
            (<tag> "input" '((type . "text") (name . "search") (size . 24))) )
         "Google" (<nbsp>)
         (<tag> "form"
            '((action . "https://www.google.com/search"))
            (<tag> "input" '((type . "text") (name . "q") (size . 24))) )
         "Scholar" (<nbsp>)
         (<tag> "form"
            '((action . "https://scholar.google.com/scholar"))
            (<tag> "input" '((type . "text") (name . "q") (size . 24))) ) ) ) )
