# 15apr23 Software Lab. Alexander Burger

(symbols '(android pico))

# Handle Downloads
(local) (VISIBILITY_VISIBLE_NOTIFY_COMPLETED onDownloadStart parse
allowScanningByMediaScanner setNotificationVisibility
setDestinationInExternalPublicDir guessFileName enqueue setDownloadListener)

(de VISIBILITY_VISIBLE_NOTIFY_COMPLETED . 1)  # DownloadManager.Request

(once
   (let Lsn (java T "android.webkit.DownloadListener")
      (def 'onDownloadStart Lsn
         '((Url Agent Cont Mime Len)
            (let Req
               (java "android.app.DownloadManager$Request" T
                  (java "android.net.Uri" 'parse Url) )
               (java Req 'allowScanningByMediaScanner)
               (java Req 'setNotificationVisibility VISIBILITY_VISIBLE_NOTIFY_COMPLETED)
               (java Req 'setDestinationInExternalPublicDir
                  (java "android.os.Environment" "DIRECTORY_DOWNLOADS")
                  (java "android.webkit.URLUtil" 'guessFileName Url (or Cont null) Mime) )
               (java
                  (java CONTEXT 'getSystemService "download")  # DownloadManager
                  'enqueue
                  Req )
               (toast ,"downloading ...") ) ) )
      (java (; CONTEXT GUI) 'runOnUiThread
         (java (; CONTEXT GUI PilView) 0 'setDownloadListener Lsn) ) ) )


# Copy URL to clipboard
(local) (setPrimaryClip newPlainText)

(de setPrimaryClip (Str)
   (java
      (java CONTEXT 'getSystemService "clipboard")  # ClipboardManager
      'setPrimaryClip
      (java "android.content.ClipData" 'newPlainText "PilBox" Str) )
   (toast ,"Copied") )


# Cookies
(local) (*CookieCallback getInstance getCookie setCookie removeAllCookies
onReceiveValue)

(de getCookie (Url)
   (java (java "android.webkit.CookieManager" 'getInstance) 'getCookie Url) )

(de setCookie (Url Val)
   (java (java "android.webkit.CookieManager" 'getInstance) 'setCookie Url Val) )

(de removeAllCookies ()
   (unless *CookieCallback
      (def 'onReceiveValue (setq *CookieCallback (java T "android.webkit.ValueCallback"))
         '((Val) (and Val (toast ,"Cookies removed"))) ) )
   (java (; CONTEXT GUI) 'runOnUiThread
      (java (java "android.webkit.CookieManager" 'getInstance) 0 'removeAllCookies *CookieCallback) ) )


# Clear Form Data
(local) (clearFormData getInstance)

(de clearFormData ()
   (java
      (java "android.webkit.WebViewDatabase" 'getInstance CONTEXT)
      'clearFormData ) )


# Search String
(local) (findAllAsync clearMatches)

(de findAllAsync (Str)
   (java (; CONTEXT GUI) 'runOnUiThread
      (java (; CONTEXT GUI PilView) 0 'findAllAsync Str) ) )

(de clearMatches ()
   (java (; CONTEXT GUI) 'runOnUiThread
      (java (; CONTEXT GUI PilView) 0 'clearMatches) ) )


# Set auto-fill values
(symbols '(browser pico android))

(local) autofill

(de autofill ()
   (when
      (make
         (iter '(url . +Autofill)
            '((This)
               (and
                  (: url)
                  (: id)
                  (: val)
                  (link (: url) (: id) @) ) )
            NIL T
            T ) )
      (java CONTEXT 'auto @) ) )
